"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var bs_logger_1 = require("bs-logger");
var fast_json_stable_stringify_1 = __importDefault(require("fast-json-stable-stringify"));
var fs_1 = require("fs");
var json5_1 = require("json5");
var path_1 = require("path");
var create_jest_preset_1 = require("../../config/create-jest-preset");
var backports_1 = require("../../util/backports");
exports.run = function (args) { return __awaiter(_this, void 0, void 0, function () {
    var nullLogger, file, filePath, name, isPackage, actualConfig, migratedConfig, usesPreset, presets, presetValue, migratedValue, presetValue, migratedValue, before, after, stringify, footNotes;
    return __generator(this, function (_a) {
        nullLogger = bs_logger_1.createLogger({ targets: [] });
        file = args._[0];
        filePath = path_1.resolve(process.cwd(), file);
        if (!fs_1.existsSync(filePath)) {
            throw new Error("Configuration file " + file + " does not exists.");
        }
        name = path_1.basename(file);
        isPackage = name === 'package.json';
        if (!/\.(js|json)$/.test(name)) {
            throw new TypeError("Configuration file " + file + " must be a JavaScript or JSON file.");
        }
        actualConfig = require(filePath);
        if (isPackage) {
            actualConfig = actualConfig.jest;
        }
        if (!actualConfig)
            actualConfig = {};
        migratedConfig = backports_1.backportJestConfig(nullLogger, actualConfig);
        if (!migratedConfig.preset && args.jestPreset) {
            migratedConfig.preset = 'ts-jest';
        }
        else if (!args.jestPreset && migratedConfig.preset === 'ts-jest') {
            delete migratedConfig.preset;
        }
        usesPreset = migratedConfig.preset === 'ts-jest';
        presets = create_jest_preset_1.createJestPreset({ allowJs: args.allowJs });
        if (migratedConfig.moduleFileExtensions && migratedConfig.moduleFileExtensions.length && usesPreset) {
            presetValue = dedupSort(presets.moduleFileExtensions).join('::');
            migratedValue = dedupSort(migratedConfig.moduleFileExtensions).join('::');
            if (presetValue === migratedValue) {
                delete migratedConfig.moduleFileExtensions;
            }
        }
        if (migratedConfig.testMatch && migratedConfig.testMatch.length && usesPreset) {
            presetValue = dedupSort(presets.testMatch).join('::');
            migratedValue = dedupSort(migratedConfig.testMatch).join('::');
            if (presetValue === migratedValue) {
                delete migratedConfig.testMatch;
            }
        }
        if (migratedConfig.transform) {
            Object.keys(migratedConfig.transform).forEach(function (key) {
                var val = migratedConfig.transform[key];
                if (typeof val === 'string' && /\/?ts-jest(?:\/preprocessor\.js)?$/.test(val)) {
                    ;
                    migratedConfig.transform[key] = 'ts-jest';
                }
            });
        }
        if (usesPreset &&
            migratedConfig.transform &&
            fast_json_stable_stringify_1.default(migratedConfig.transform) === fast_json_stable_stringify_1.default(presets.transform)) {
            delete migratedConfig.transform;
        }
        cleanupConfig(actualConfig);
        cleanupConfig(migratedConfig);
        before = fast_json_stable_stringify_1.default(actualConfig);
        after = fast_json_stable_stringify_1.default(migratedConfig);
        if (after === before) {
            process.stderr.write("\nNo migration needed for given Jest configuration\n    ");
            return [2];
        }
        stringify = /\.json$/.test(file) ? JSON.stringify : json5_1.stringify;
        footNotes = [];
        if (usesPreset && migratedConfig.transform) {
            footNotes.push("\nI couldn't check if your \"transform\" value is the same as mine which is: " + stringify(presets.transform, undefined, '  ') + "\nIf it is the case, you can safely remove the \"transform\" from what I've migrated.\n");
        }
        process.stderr.write("\nMigrated Jest configuration:\n");
        process.stdout.write(stringify(migratedConfig, undefined, '  ') + "\n");
        if (footNotes.length) {
            process.stderr.write("\n" + footNotes.join('\n') + "\n");
        }
        return [2];
    });
}); };
function cleanupConfig(config) {
    if (config.globals) {
        if (config.globals['ts-jest'] && Object.keys(config.globals['ts-jest']).length === 0) {
            delete config.globals['ts-jest'];
        }
        if (Object.keys(config.globals).length === 0) {
            delete config.globals;
        }
    }
    if (config.transform && Object.keys(config.transform).length === 0) {
        delete config.transform;
    }
    if (config.moduleFileExtensions) {
        config.moduleFileExtensions = dedupSort(config.moduleFileExtensions);
        if (config.moduleFileExtensions.length === 0)
            delete config.moduleFileExtensions;
    }
    if (config.testMatch) {
        config.testMatch = dedupSort(config.testMatch);
        if (config.testMatch.length === 0)
            delete config.testMatch;
    }
}
function dedupSort(arr) {
    return arr
        .filter(function (s, i, a) { return a.findIndex(function (e) { return s.toString() === e.toString(); }) === i; })
        .sort(function (a, b) { return (a.toString() > b.toString() ? 1 : a.toString() < b.toString() ? -1 : 0); });
}
exports.help = function () { return __awaiter(_this, void 0, void 0, function () {
    return __generator(this, function (_a) {
        process.stdout.write("\nUsage:\n  ts-jest config:migrate [options] <config-file>\n\nArguments:\n  <config-file>         Can be a js or json Jest config file. If it is a\n                        package.json file, the configuration will be read from\n                        the \"jest\" property.\n\nOptions:\n  --allow-js            ts-jest will be used to process JS files as well\n  --no-jest-preset      Disable the use of Jest presets\n");
        return [2];
    });
}); };
