"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var semver_1 = __importDefault(require("semver"));
var logger_1 = require("./logger");
var logger = logger_1.rootLogger.child({ namespace: 'hacks' });
exports.patchBabelCore_githubIssue6577 = function (babel) {
    if (typeof babel.version === 'string' && semver_1.default.satisfies(babel.version, '>=6 <7')) {
        try {
            var File = require('babel-core/lib/transformation/file').File;
            File.prototype.initOptions = (function (original) {
                return function initOptions(opt) {
                    var before = opt.sourceMaps;
                    var result = original.apply(this, arguments);
                    if (before && before !== result.sourceMaps) {
                        result.sourceMaps = before;
                    }
                    return result;
                };
            })(File.prototype.initOptions);
            logger.info('patched babel-core/lib/transformation/file');
        }
        catch (err) { }
    }
    return babel;
};
