import { ModulePatcher, TBabelCore, TBabelJest, TTypeScript, TsJestImporter } from '../types';
import { ImportReasons } from './messages';
interface ImportOptions {
    alternatives?: string[];
    installTip?: string | Array<{
        module: string;
        label: string;
    }>;
}
export declare class Importer implements TsJestImporter {
    protected _patches: {
        [moduleName: string]: ModulePatcher[];
    };
    static readonly instance: Importer;
    constructor(_patches?: {
        [moduleName: string]: ModulePatcher[];
    });
    babelJest(why: ImportReasons): TBabelJest;
    babelCore(why: ImportReasons): TBabelCore;
    typescript(why: ImportReasons, which: string): TTypeScript;
    tryThese(moduleName: string, ...fallbacks: string[]): any;
    protected _patch<T>(name: string, unpatched: T): T;
    protected _import(why: string, moduleName: string, { alternatives, installTip }?: ImportOptions): any;
}
export declare const importer: Importer;
declare let requireModule: (mod: string) => any;
export declare function __requireModule(localRequire: typeof requireModule): void;
export {};
