export declare enum ExpectedVersions {
    Jest = ">=22 <24",
    TypeScript = ">=2.7 <4",
    BabelJest = ">=22 <24",
    BabelCoreLegacy = ">=6 <7 || 7.0.0-bridge.0",
    BabelCore = ">=7.0.0-beta.0 <8"
}
export interface VersionChecker {
    raise: () => boolean | never;
    warn: () => boolean;
    forget: () => void;
}
export declare const VersionCheckers: {
    jest: VersionChecker;
    typescript: VersionChecker;
    babelJest: VersionChecker;
    babelCoreLegacy: VersionChecker;
    babelCore: VersionChecker;
};
